<?php
/* Autor...:  */
/* Esquema.: PRD_OrdenCab.xml */
/* Generado: 2021-04-06 20:52:06 */

/* Metodos de acceso a los campos de la tabla PRD_OrdenCab */
abstract class BasePRD_OrdenCabBN
{
    /* Campos de la tabla */
    private $i_IdOrdenCab;    // IdOrdenCab: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $d_FechaOrden;    // FechaOrden: ( no definido )
    private $s_TipoOrden;    // TipoOrden: ( no definido )
    private $s_IdAlmacen;    // IdAlmacen: ( no definido )
    private $i_IdProyecto;    // IdProyecto: ( no definido )
    private $s_ProyectoDesc;    // ProyectoDesc: ( no definido )
    private $i_ProFinalId;    // ProFinalId: ( no definido )
    private $i_IdDocRef;    // IdDocRef: ( no definido )
    private $s_DocNumRef;    // DocNumRef: ( no definido )
    private $s_IdAlmacenRef;    // IdAlmacenRef: ( no definido )
    private $s_Comentario;    // Comentario: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_IdTipoDocumentoSal;    // IdTipoDocumentoSal: ( no definido )
    private $s_IdNumeroDocumentoSal;    // IdNumeroDocumentoSal: ( no definido )
    private $s_IdTransaccionSal;    // IdTransaccionSal: ( no definido )
    private $s_IdTipoDocumentoIng;    // IdTipoDocumentoIng: ( no definido )
    private $s_IdNumeroDocumentoIng;    // IdNumeroDocumentoIng: ( no definido )
    private $s_IdTransaccionIng;    // IdTransaccionIng: ( no definido )
    private $s_IdTipoDocumentoTrf;    // IdTipoDocumentoTrf: ( no definido )
    private $s_IdNumeroDocumentoTrf;    // IdNumeroDocumentoTrf: ( no definido )
    private $s_IdTransaccionTrf;    // IdTransaccionTrf: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo IdOrdenCab */
    public function setIdOrdenCab( $i_IdOrdenCab )
    {
        $this->i_IdOrdenCab = $i_IdOrdenCab;
    }

    /* Obtiene el valor del campo IdOrdenCab */
    public function getIdOrdenCab()
    {
        return $this->i_IdOrdenCab;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo FechaOrden */
    public function setFechaOrden( $d_FechaOrden )
    {
        $this->d_FechaOrden = $d_FechaOrden;
    }

    /* Obtiene el valor del campo FechaOrden */
    public function getFechaOrden()
    {
        return $this->d_FechaOrden;
    }

    /* Establece el valor del campo TipoOrden */
    public function setTipoOrden( $s_TipoOrden )
    {
        $this->s_TipoOrden = $s_TipoOrden;
    }

    /* Obtiene el valor del campo TipoOrden */
    public function getTipoOrden()
    {
        return $this->s_TipoOrden;
    }

    /* Establece el valor del campo IdAlmacen */
    public function setIdAlmacen( $s_IdAlmacen )
    {
        $this->s_IdAlmacen = $s_IdAlmacen;
    }

    /* Obtiene el valor del campo IdAlmacen */
    public function getIdAlmacen()
    {
        return $this->s_IdAlmacen;
    }

    /* Establece el valor del campo IdProyecto */
    public function setIdProyecto( $i_IdProyecto )
    {
        $this->i_IdProyecto = $i_IdProyecto;
    }

    /* Obtiene el valor del campo IdProyecto */
    public function getIdProyecto()
    {
        return $this->i_IdProyecto;
    }

    /* Establece el valor del campo ProyectoDesc */
    public function setProyectoDesc( $s_ProyectoDesc )
    {
        $this->s_ProyectoDesc = $s_ProyectoDesc;
    }

    /* Obtiene el valor del campo ProyectoDesc */
    public function getProyectoDesc()
    {
        return $this->s_ProyectoDesc;
    }

    /* Establece el valor del campo ProFinalId */
    public function setProFinalId( $i_ProFinalId )
    {
        $this->i_ProFinalId = $i_ProFinalId;
    }

    /* Obtiene el valor del campo ProFinalId */
    public function getProFinalId()
    {
        return $this->i_ProFinalId;
    }

    /* Establece el valor del campo IdDocRef */
    public function setIdDocRef( $i_IdDocRef )
    {
        $this->i_IdDocRef = $i_IdDocRef;
    }

    /* Obtiene el valor del campo IdDocRef */
    public function getIdDocRef()
    {
        return $this->i_IdDocRef;
    }

    /* Establece el valor del campo DocNumRef */
    public function setDocNumRef( $s_DocNumRef )
    {
        $this->s_DocNumRef = $s_DocNumRef;
    }

    /* Obtiene el valor del campo DocNumRef */
    public function getDocNumRef()
    {
        return $this->s_DocNumRef;
    }

    /* Establece el valor del campo IdAlmacenRef */
    public function setIdAlmacenRef( $s_IdAlmacenRef )
    {
        $this->s_IdAlmacenRef = $s_IdAlmacenRef;
    }

    /* Obtiene el valor del campo IdAlmacenRef */
    public function getIdAlmacenRef()
    {
        return $this->s_IdAlmacenRef;
    }

    /* Establece el valor del campo Comentario */
    public function setComentario( $s_Comentario )
    {
        $this->s_Comentario = $s_Comentario;
    }

    /* Obtiene el valor del campo Comentario */
    public function getComentario()
    {
        return $this->s_Comentario;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo IdTipoDocumentoSal */
    public function setIdTipoDocumentoSal( $s_IdTipoDocumentoSal )
    {
        $this->s_IdTipoDocumentoSal = $s_IdTipoDocumentoSal;
    }

    /* Obtiene el valor del campo IdTipoDocumentoSal */
    public function getIdTipoDocumentoSal()
    {
        return $this->s_IdTipoDocumentoSal;
    }

    /* Establece el valor del campo IdNumeroDocumentoSal */
    public function setIdNumeroDocumentoSal( $s_IdNumeroDocumentoSal )
    {
        $this->s_IdNumeroDocumentoSal = $s_IdNumeroDocumentoSal;
    }

    /* Obtiene el valor del campo IdNumeroDocumentoSal */
    public function getIdNumeroDocumentoSal()
    {
        return $this->s_IdNumeroDocumentoSal;
    }

    /* Establece el valor del campo IdTransaccionSal */
    public function setIdTransaccionSal( $s_IdTransaccionSal )
    {
        $this->s_IdTransaccionSal = $s_IdTransaccionSal;
    }

    /* Obtiene el valor del campo IdTransaccionSal */
    public function getIdTransaccionSal()
    {
        return $this->s_IdTransaccionSal;
    }

    /* Establece el valor del campo IdTipoDocumentoIng */
    public function setIdTipoDocumentoIng( $s_IdTipoDocumentoIng )
    {
        $this->s_IdTipoDocumentoIng = $s_IdTipoDocumentoIng;
    }

    /* Obtiene el valor del campo IdTipoDocumentoIng */
    public function getIdTipoDocumentoIng()
    {
        return $this->s_IdTipoDocumentoIng;
    }

    /* Establece el valor del campo IdNumeroDocumentoIng */
    public function setIdNumeroDocumentoIng( $s_IdNumeroDocumentoIng )
    {
        $this->s_IdNumeroDocumentoIng = $s_IdNumeroDocumentoIng;
    }

    /* Obtiene el valor del campo IdNumeroDocumentoIng */
    public function getIdNumeroDocumentoIng()
    {
        return $this->s_IdNumeroDocumentoIng;
    }

    /* Establece el valor del campo IdTransaccionIng */
    public function setIdTransaccionIng( $s_IdTransaccionIng )
    {
        $this->s_IdTransaccionIng = $s_IdTransaccionIng;
    }

    /* Obtiene el valor del campo IdTransaccionIng */
    public function getIdTransaccionIng()
    {
        return $this->s_IdTransaccionIng;
    }

    /* Establece el valor del campo IdTipoDocumentoTrf */
    public function setIdTipoDocumentoTrf( $s_IdTipoDocumentoTrf )
    {
        $this->s_IdTipoDocumentoTrf = $s_IdTipoDocumentoTrf;
    }

    /* Obtiene el valor del campo IdTipoDocumentoTrf */
    public function getIdTipoDocumentoTrf()
    {
        return $this->s_IdTipoDocumentoTrf;
    }

    /* Establece el valor del campo IdNumeroDocumentoTrf */
    public function setIdNumeroDocumentoTrf( $s_IdNumeroDocumentoTrf )
    {
        $this->s_IdNumeroDocumentoTrf = $s_IdNumeroDocumentoTrf;
    }

    /* Obtiene el valor del campo IdNumeroDocumentoTrf */
    public function getIdNumeroDocumentoTrf()
    {
        return $this->s_IdNumeroDocumentoTrf;
    }

    /* Establece el valor del campo IdTransaccionTrf */
    public function setIdTransaccionTrf( $s_IdTransaccionTrf )
    {
        $this->s_IdTransaccionTrf = $s_IdTransaccionTrf;
    }

    /* Obtiene el valor del campo IdTransaccionTrf */
    public function getIdTransaccionTrf()
    {
        return $this->s_IdTransaccionTrf;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdOrdenCab' => $this->getIdOrdenCab(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'FechaOrden' => $this->getFechaOrden(),
            'TipoOrden' => $this->getTipoOrden(),
            'IdAlmacen' => $this->getIdAlmacen(),
            'IdProyecto' => $this->getIdProyecto(),
            'ProyectoDesc' => $this->getProyectoDesc(),
            'ProFinalId' => $this->getProFinalId(),
            'IdDocRef' => $this->getIdDocRef(),
            'DocNumRef' => $this->getDocNumRef(),
            'IdAlmacenRef' => $this->getIdAlmacenRef(),
            'Comentario' => $this->getComentario(),
            'Estado' => $this->getEstado(),
            'IdTipoDocumentoSal' => $this->getIdTipoDocumentoSal(),
            'IdNumeroDocumentoSal' => $this->getIdNumeroDocumentoSal(),
            'IdTransaccionSal' => $this->getIdTransaccionSal(),
            'IdTipoDocumentoIng' => $this->getIdTipoDocumentoIng(),
            'IdNumeroDocumentoIng' => $this->getIdNumeroDocumentoIng(),
            'IdTransaccionIng' => $this->getIdTransaccionIng(),
            'IdTipoDocumentoTrf' => $this->getIdTipoDocumentoTrf(),
            'IdNumeroDocumentoTrf' => $this->getIdNumeroDocumentoTrf(),
            'IdTransaccionTrf' => $this->getIdTransaccionTrf(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto PRD_OrdenCabBN desde un RecordSet */
    public static function retrieveByRs( $o_PRD_OrdenCabRs )
    {
        $o_PRD_OrdenCabBN = new PRD_OrdenCabBN();
        $o_PRD_OrdenCabBN->setIdOrdenCab( ( integer ) $o_PRD_OrdenCabRs[ "IdOrdenCab" ] );
        $o_PRD_OrdenCabBN->setIdCompania( ( integer ) $o_PRD_OrdenCabRs[ "IdCompania" ] );
        $o_PRD_OrdenCabBN->setIdSucursal( ( integer ) $o_PRD_OrdenCabRs[ "IdSucursal" ] );
        $o_PRD_OrdenCabBN->setFechaOrden( utilTimestamp::getTimestamp( $o_PRD_OrdenCabRs[ "FechaOrden" ], "Y-m-d" ) );
        $o_PRD_OrdenCabBN->setTipoOrden( $o_PRD_OrdenCabRs[ "TipoOrden" ] );
        $o_PRD_OrdenCabBN->setIdAlmacen( $o_PRD_OrdenCabRs[ "IdAlmacen" ] );
        $o_PRD_OrdenCabBN->setIdProyecto( ( integer ) $o_PRD_OrdenCabRs[ "IdProyecto" ] );
        $o_PRD_OrdenCabBN->setProyectoDesc( $o_PRD_OrdenCabRs[ "ProyectoDesc" ] );
        $o_PRD_OrdenCabBN->setProFinalId( ( integer ) $o_PRD_OrdenCabRs[ "ProFinalId" ] );
        $o_PRD_OrdenCabBN->setIdDocRef( ( integer ) $o_PRD_OrdenCabRs[ "IdDocRef" ] );
        $o_PRD_OrdenCabBN->setDocNumRef( $o_PRD_OrdenCabRs[ "DocNumRef" ] );
        $o_PRD_OrdenCabBN->setIdAlmacenRef( $o_PRD_OrdenCabRs[ "IdAlmacenRef" ] );
        $o_PRD_OrdenCabBN->setComentario( $o_PRD_OrdenCabRs[ "Comentario" ] );
        $o_PRD_OrdenCabBN->setEstado( $o_PRD_OrdenCabRs[ "Estado" ] );
        $o_PRD_OrdenCabBN->setIdTipoDocumentoSal( $o_PRD_OrdenCabRs[ "IdTipoDocumentoSal" ] );
        $o_PRD_OrdenCabBN->setIdNumeroDocumentoSal( $o_PRD_OrdenCabRs[ "IdNumeroDocumentoSal" ] );
        $o_PRD_OrdenCabBN->setIdTransaccionSal( $o_PRD_OrdenCabRs[ "IdTransaccionSal" ] );
        $o_PRD_OrdenCabBN->setIdTipoDocumentoIng( $o_PRD_OrdenCabRs[ "IdTipoDocumentoIng" ] );
        $o_PRD_OrdenCabBN->setIdNumeroDocumentoIng( $o_PRD_OrdenCabRs[ "IdNumeroDocumentoIng" ] );
        $o_PRD_OrdenCabBN->setIdTransaccionIng( $o_PRD_OrdenCabRs[ "IdTransaccionIng" ] );
        $o_PRD_OrdenCabBN->setIdTipoDocumentoTrf( $o_PRD_OrdenCabRs[ "IdTipoDocumentoTrf" ] );
        $o_PRD_OrdenCabBN->setIdNumeroDocumentoTrf( $o_PRD_OrdenCabRs[ "IdNumeroDocumentoTrf" ] );
        $o_PRD_OrdenCabBN->setIdTransaccionTrf( $o_PRD_OrdenCabRs[ "IdTransaccionTrf" ] );
        $o_PRD_OrdenCabBN->setUsuarioCreacion( $o_PRD_OrdenCabRs[ "UsuarioCreacion" ] );
        $o_PRD_OrdenCabBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_PRD_OrdenCabRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_PRD_OrdenCabBN->setUsuarioModificacion( $o_PRD_OrdenCabRs[ "UsuarioModificacion" ] );
        $o_PRD_OrdenCabBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_PRD_OrdenCabRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_PRD_OrdenCabBN;
    }
}
?>